# Platform Release
## 适用于
* Android/iOS/WP8
* xface-js
* default-app
* test-template
* test-apps

## 版本定义
1. 参考[Versioning](http://gitlab.polyvi.com/xface/xsrc/blob/master/guides/versioning.md)
2. 本类repo的开发分支是master，有多个发布分支，如3.2.x，3.3.x

## 发布周期
大概为一月一次，稍候于对应的cordova-platform


## 发布流程和工具支持
```
$ xsrc release -r <repo>    # platform = android/ios/wp8/js/default-app/test-apps/template

# 以3.2.x Android为例

# 1, do rc1 release, make sure js/default-app go first
$ xsrc release -r js -r default-app -r android    # xsrc提示输入版本号，填入x.y.z-rc1
$ xsrc repo-push -r js -r default-app -r android -b master -b 3.2.x
$ xsrc foreach -r js -r default-app -r android "git push --tags"

# 2-4, 中间过程为test, bug fix等

# 5, then do final release
$ xsrc release -r js -r default-app -r android    # 输入版本号x.y.z作为正式发布

# 6, push to gitlab
$ xsrc repo-push -r js -r default-app -r android -b master -b 3.2.x
$ xsrc foreach -r js -r default-app -r android "git push --tags"
```
1. 先做rc1 pre-release
2. 对cli做相应的[release](http://gitlab.polyvi.com/xface/xsrc/blob/master/guides/cli-release.md)
3. 进行测试，测试项目包括
   1. 每个platform的./bin/create script
   2. 测试cli是否可以upgrade platform `xface platform update android`
   3. xface-mobile-spec
   4. xface-test-apps
   5. 其它应用
4. **bug fix从master cherry-pick到对应的release branch**
5. 再次回归测试通过后，准备正式release
6. 各种确认无误后，提交到gitlab
7. 宣布release，发邮件，blog等

## 注意
* **js/default-app必须先于其它repo做release，因为它们依赖二者**
* 注意releasenotex的描述，可能需要手工去掉不相关的comment，并修饰文字易于用户理解

## References
* [platform release - twiki](http://twiki.polyvi.com/twiki5/bin/view/Dev/ProjApolloV32PlatformRelease)
* [cordova cadence release](https://github.com/apache/cordova-coho/blob/master/docs/cadence-release-process.md)




