# Plugin Release
## 适用于
* cordova-plugin-x
* xface-extension-x
* xface-extra-x

## 版本定义
1. 参考[Versioning](http://gitlab.polyvi.com/xface/xsrc/blob/master/guides/versioning.md)
2. 本类repo开发分支为dev，发布分支为master
3. 插件无beta/rc版本，而是快速发布小版本
4. 发布记录，cordova为releasenotes.md，xface为**releasenotex.md**

## 发布周期
大概为一周一次，稍后于对应的cordova-plugin-x，若没有变化，可不做release


## 发布流程和工具支持
```
# 测试通过后
$ xsrc release -r cordova-plugin-file

# 检查发布是否有误后
$ xsrc repo-push -r cordova-plugin-file -b master -b dev
$ xsrc foreach -r cordova-plugin-file "git push --tags"

# 发布到plugin server
$ cd /reposet/cordova-plugin-file
$ git checkout master
$ xplugin publish .
```
第一次发布时需要添加用户，目前使用统一账号
用户名：polyvi，密码：xface，邮箱：dev@polyvi.com

添加用户的命令
```
$ xplugin adduser
```
然后根据提示输入上面的用户信息

## 注意
* 对于插件，若有critical bug fix，则从dev cherry-pick到master，一般的bug fix，则保留到下一次release
* 注意releasenotex的描述，可能需要手工去掉不相关的comment，并修饰文字易于用户理解

## References
* [plugin release - twiki](http://twiki.polyvi.com/twiki5/bin/view/Dev/ProjApolloV32PluginRelease)
* [cordova plugin release](https://github.com/apache/cordova-coho/blob/master/docs/plugins-release-process.md)