# Versioning
本文档定义了从xface 3.2.0开始后的版本策略

* 基本规则必须遵循[SemVer](https://github.com/mojombo/semver/blob/master/semver.md)规范
* 开发分支版本为x.y.z-dev，发布分支参考SemVer

## Platform
```
3.2.0        # 正式的主版本
3.2.0-rc1    # 测试版本
3.2.1        # 正式的小版本
```

适用于

* platforms (Android, iOS, WP8)
* xface-js
* test-template
* default-app
* test-apps

## CLI
cli的主版本和其对应的platform保持一致

```
3.2.0-0.0.1      # 适用于3.2.0-rc1 platform版本
3.2.0-0.0.2      # 适用于3.2.0-rc2 platform版本
3.2.0            # 适用于3.2.0 platform主版本
x.y.0            # 适用于x.y.* platform，如当platform升级patch version，CLI没有任何变化
```

## Plugin
### xface-extension-xxx

```
1.0.0    # 第一个正式发布的版本
1.0.1    # patch version
1.1.0    # minor version
```
从1.0.0起始，严格遵循[SemVer](https://github.com/mojombo/semver/blob/master/semver.md)
### cordova-plugin-xxx

xface的cordova-plugin-xxx fork，不保持cordova version，起始版本从最初fork的cordova version开始

## xface和cordova的版本关系
1. 若某版本xface-x依赖某版本cordova-x，目前这种关系没有显式的描述和记录
2. 在cli，plugin的实现中，已存在的cordova版本依赖，如
   1. cli中的版本检测
   2. plugin dependency
   
   目前策略是均改为*xface version*，即**在xface的体系中，尽量使用xface version**, 这样做的好处是简化了xface版本管理，但缺乏简单的把xface version还原为对应的cordova version的手段

## Reference
* [cordova versioning strategies](https://github.com/apache/cordova-coho/blob/master/docs/versioning-and-release-strategy.md)